/*
 * Created on 12 Jun 2009
 */
package org.fluidproject.engage;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.fluidproject.engage.xml.XPPJSONGenerator;

import uk.org.ponder.json.support.JSONProvider;
import uk.org.ponder.saxalizer.SAXalizerMappingContext;

public class Importer {

    public static final String dir = "C:\\Users\\Fluid\\workspace\\fluid-engage-kettle\\src\\test\\java\\org\\fluidproject\\engage\\";
    
    public InputStream getResource(String name) throws FileNotFoundException {
        return new FileInputStream(dir + name);
    }
    
    public InputStream readResource(URL url) throws IOException {
        String response = "";
        BufferedReader in = 
            new BufferedReader(new InputStreamReader(url.openStream()));
        String str;
        while ((str = in.readLine()) != null) {
            response = response.concat(str);
        }
        in.close();
        return new ByteArrayInputStream(response.getBytes("ISO-8859-1"));
    }
    
    public void prepareImport(String urlString) throws Exception {
        URL url = new URL(urlString);
        JSONProvider provider = new JSONProvider();
        
        provider.setMappingContext(new SAXalizerMappingContext());
        InputStream confis = this.getResource("config.json");
        List patterns = (List) provider.readObject(new ArrayList(), confis);
        confis.close();
        
        XPPJSONGenerator gen = new XPPJSONGenerator(patterns);
        InputStream fis = this.readResource(url);
        gen.parseStream(fis);
        fis.close();
        
        System.out.println(((Map)gen.root.get("exhibit")).get("introduction"));
    }
    public static void main(String[] args) {
        Importer importer = new Importer();
        try {
            importer.prepareImport("http://www.mccord-museum.qc.ca/fluidengage/xml/exhibit.php?exhibitID=57&Lang=1");
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
}
